package com.friday.custody.dao;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.friday.custody.entity.CustShareInfoEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 
 * 
 * @author lyb
 * @email k0051582@gmail.com
 * @date 2022-01-05 14:07:22
 */
@Mapper
public interface CustShareInfoDao extends BaseMapper<CustShareInfoEntity> {

    String getFundCodeByInnerFundCode(@Param("innerFundCode") String innerFundCode,
                                      @Param("trustNo") String trustNo,
                                      @Param("admin") String admin);

    List<CustShareInfoEntity> queryByFundInfo(CustShareInfoEntity entity);

    void updateShares(List<CustShareInfoEntity> custShareInfoEntities);

    void updateDataToZero(@Param("zeroList") List<CustShareInfoEntity> toUpdateZeroList);

    default Set<String> queryUniqueKeyList(List<String> rawUniqueKeyList){
        LambdaQueryWrapper<CustShareInfoEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.select(CustShareInfoEntity::getUniqueKey).in(CustShareInfoEntity::getUniqueKey, rawUniqueKeyList);
        List<CustShareInfoEntity> entityList = this.selectList(queryWrapper);
        Set<String> result = entityList.stream().map(t -> t.getUniqueKey()).collect(Collectors.toSet());
        return result;
    }

    default int deleteByUniqueKeys(Set<String> uniqueKeySet){
        LambdaQueryWrapper<CustShareInfoEntity> queryWrapper = new LambdaQueryWrapper();
        queryWrapper.in(CustShareInfoEntity::getUniqueKey, uniqueKeySet);
        return delete(queryWrapper);
    }
}
